[ARVADOS-WORKBENCH2] updated: 1.4.1-228-gf8eb236c

Git user git at public.arvados.org
Fri Jan 24 15:43:25 UTC 2020


Summary of changes:
 Makefile             | 22 ++++++++--------------
 version-at-commit.sh | 48 ++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 56 insertions(+), 14 deletions(-)
 create mode 100755 version-at-commit.sh

       via  f8eb236cca1eaf973676e3b9d5a2fe61a00248d0 (commit)
      from  e8642c8ae5a24a262c853fa43fcfcf3302814786 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.


commit f8eb236cca1eaf973676e3b9d5a2fe61a00248d0
Author: Peter Amstutz <peter.amstutz at curii.com>
Date:   Fri Jan 24 10:40:37 2020 -0500

    Fix package build, use version-at-commit script for version
    
    no issue #
    
    Arvados-DCO-1.1-Signed-off-by: Peter Amstutz <peter.amstutz at curii.com>

diff --git a/Makefile b/Makefile
index d90d8e81..8e29db82 100644
--- a/Makefile
+++ b/Makefile
@@ -8,26 +8,17 @@ SHELL := /bin/bash
 
 APP_NAME?=arvados-workbench2
 
-# GIT_TAG is the last tagged stable release (i.e. 1.2.0)
-GIT_TAG?=$(shell git describe --abbrev=0)
-
-# TS_GIT is the timestamp in the current directory (i.e. 1528815021).
-# Note that it will only change if files change.
-TS_GIT?=$(shell git log -n1 --first-parent "--format=format:%ct" .)
-
-# DATE_FROM_TS_GIT is the human(ish)-readable version of TS_GIT
-# 1528815021 -> 20180612145021
-DATE_FROM_TS_GIT?=$(shell date -ud @$(TS_GIT) +%Y%m%d%H%M%S)
-
 # VERSION uses all the above to produce X.Y.Z.timestamp
 # something in the lines of 1.2.0.20180612145021, this will be the package version
 # it can be overwritten when invoking make as in make packages VERSION=1.2.0
-VERSION?=$(GIT_TAG).$(DATE_FROM_TS_GIT)
+VERSION?=$(shell ./version-at-commit.sh HEAD)
 
 # ITERATION is the package iteration, intended for manual change if anything non-code related
 # changes in the package. (i.e. example config files externally added
 ITERATION?=1
 
+TARGETS?="centos7 debian8 debian9 debian10 ubuntu1404 ubuntu1604 ubuntu1804"
+
 DESCRIPTION=Arvados Workbench2 - Arvados is a free and open source platform for big data science.
 MAINTAINER=Ward Vandewege <wvandewege at veritasgenetics.com>
 
@@ -106,8 +97,8 @@ $(RPM_FILE): build
 	 $(WORKSPACE)/build/=$(DEST_DIR)
 
 copy: $(DEB_FILE) $(RPM_FILE)
-	mkdir packages
-	for target in $^ ; do \
+	for target in $(TARGETS) ; do \
+	        mkdir -p packages/$$target
 		if [[ $$target =~ ^centos ]]; then
 			cp -p $(RPM_FILE) packages/$$target ; \
 		else
@@ -119,3 +110,6 @@ copy: $(DEB_FILE) $(RPM_FILE)
 
 # use FPM to create DEB and RPM
 packages: copy
+
+workbench2-build-image:
+	docker build -t workbench2-build .
diff --git a/version-at-commit.sh b/version-at-commit.sh
new file mode 100755
index 00000000..89684cf2
--- /dev/null
+++ b/version-at-commit.sh
@@ -0,0 +1,48 @@
+#!/bin/bash
+
+set -e -o pipefail
+commit="$1"
+versionglob="[0-9].[0-9]*.[0-9]*"
+devsuffix=".dev"
+
+# automatically assign version
+#
+# handles the following cases:
+#
+# 1. commit is directly tagged.  print that.
+#
+# 2. commit is on master or a development branch, the nearest tag is older
+#    than commit where this branch joins master.
+#    -> take greatest version tag in repo X.Y.Z and assign X.(Y+1).0
+#
+# 3. commit is on a release branch, the nearest tag is newer
+#    than the commit where this branch joins master.
+#    -> take nearest tag X.Y.Z and assign X.Y.(Z+1)
+
+tagged=$(git tag --points-at "$commit")
+
+if [[ -n "$tagged" ]] ; then
+    echo $tagged
+else
+    # 1. get the nearest tag with 'git describe'
+    # 2. get the merge base between this commit and master
+    # 3. if the tag is an ancestor of the merge base,
+    #    (tag is older than merge base) increment minor version
+    #    else, tag is newer than merge base, so increment point version
+
+    nearest_tag=$(git describe --tags --abbrev=0 --match "$versionglob" "$commit")
+    merge_base=$(git merge-base origin/master "$commit")
+
+    if git merge-base --is-ancestor "$nearest_tag" "$merge_base" ; then
+        # x.(y+1).0.devTIMESTAMP, where x.y.z is the newest version that does not contain $commit
+	# grep reads the list of tags (-f) that contain $commit and filters them out (-v)
+	# this prevents a newer tag from retroactively changing the versions of everything before it
+        v=$(git tag | grep -vFf <(git tag --contains "$commit") | sort -Vr | head -n1 | perl -pe 's/\.(\d+)\.\d+/".".($1+1).".0"/e')
+    else
+        # x.y.(z+1).devTIMESTAMP, where x.y.z is the latest released ancestor of $commit
+        v=$(echo $nearest_tag | perl -pe 's/(\d+)$/$1+1/e')
+    fi
+    isodate=$(TZ=UTC git log -n1 --format=%cd --date=iso "$commit")
+    ts=$(TZ=UTC date --date="$isodate" "+%Y%m%d%H%M%S")
+    echo "${v}${devsuffix}${ts}"
+fi

-----------------------------------------------------------------------


hooks/post-receive
-- 




More information about the arvados-commits mailing list